
from panda3d.core import CollisionNode, CollisionHandlerQueue
from panda3d.bullet import BulletWorld, BulletRigidBodyNode

def create_collision_simulation():
    # Initialize the world
    world = BulletWorld()
    
    # Create a collision node
    collisionNode = CollisionNode('box')
    collisionNode.addSolid(CollisionBox(1, 1, 1))
    
    # Create a rigid body node
    rigidBodyNode = BulletRigidBodyNode('box')
    rigidBodyNode.addCollideMask(BitMask32(1))
    rigidBodyNode.addCollisionNode(collisionNode)
    
    # Add the rigid body to the world
    world.attachRigidBody(rigidBodyNode)
    
    # Create a handler queue
    queue = CollisionHandlerQueue()
    
    # Add the collision node to the handler queue
    world.addCollisionHandler(collisionNode, rigidBodyNode, queue)
    
    # Run the simulation
    while True:
        # Update the world
        world.doStep(0.016)
        
        # Handle collisions
        queue.processCollisions()
        
        # Sleep to control the simulation speed
        import time
        time.sleep(0.01)



